package com.tistory.uiandwe;

import java.net.URL;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.TimeUnit;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserFactory;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.res.Resources;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.SurfaceHolder.Callback;
import android.widget.Toast;

public class Stretching extends Activity implements Callback {
	/** Called when the activity is first created. */
    
	private SurfaceView surface;
	private SurfaceHolder holder;
	private Paint backgroundPaint;
	private Bitmap backgroundBitmap;
	private Paint mPaint;
	private GameLoop gameLoop;
	private Typeface mFace;
	private String fontpath = "font/cool.ttf";
	private int fontsize = 40;
	private boolean check = false;
	private TimerTask videothread;
	private Timer videotimer;
	private TimerTask weatherthread;
	private Timer weathertimer;
	private boolean threadcheck = false;
	private int threadtimehour = 30000;
	private int threadtimemin = 30000;
	private final static String T_NAME = "stretching";
	private SQLiteDatabase db;
	private final static String DB_NAME = "uiandwe.db"; // DB name setting
	private final static int DB_MODE = Context.MODE_PRIVATE;
	private Bitmap mManImage[] = new Bitmap[4];
	private Bitmap mImage = null;
	private Resources res;
	String weather = "";
	String selectregion = "군산";
	private Typeface mweather;
	private int weatherfontsize = 30;
	private Paint mPaintweather;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		

		
		
		backgroundPaint = new Paint();
		backgroundPaint.setColor(Color.WHITE);
		backgroundPaint.setAlpha(90);
		
		
		surface = (SurfaceView) findViewById(R.id.surfaceview);
		holder = surface.getHolder();
		surface.getHolder().addCallback(this);

		mFace = Typeface.createFromAsset(getAssets(), fontpath);
		mPaint = new Paint();
		mPaint.setColor(Color.BLACK);
		mPaint.setTextSize(fontsize);
		mPaint.setTypeface(mFace);
		
		mweather = Typeface.createFromAsset(getAssets(), fontpath);
		mPaintweather = new Paint();
		mPaintweather.setColor(Color.BLACK);
		mPaintweather.setTextSize(weatherfontsize);
		mPaintweather.setTypeface(mweather);

		res = super.getResources();
		mManImage[0] = BitmapFactory.decodeResource(res, R.drawable.sunny);
		mManImage[1] = BitmapFactory.decodeResource(res, R.drawable.rain);
		mManImage[2] = BitmapFactory.decodeResource(res, R.drawable.cloud);
		mManImage[3] = BitmapFactory.decodeResource(res, R.drawable.mist);
		mImage = BitmapFactory.decodeResource(res, R.drawable.icon);
		backgroundBitmap = BitmapFactory.decodeResource(res, R.drawable.background);

		openDB();
		 createTable();
		 selectData();
	
		weatherthread = new TimerTask() {
			public void run() {				
				parser();
			}
		};
		weathertimer = new Timer();
		weathertimer.schedule(weatherthread, 5000, 600000); 		  
		
		/*
		videothread = new TimerTask() {
			public void run() {
				if (threadcheck == false) {
					Intent intent = new Intent(Stretching.this, ViewVideo.class);
					intent.putExtra("videofilename", "/sdcard/movie/oh.mp4");
					startActivity(intent);
				}
			}
		};
		videotimer = new Timer();
		videotimer.schedule(videothread, 10000, threadtimehour+threadtimemin); 		  
		*/		
	}

	protected void onPause() {
		super.onPause();		
		//sql 읽고 시간 설정하는거
	}

	protected void onResume() {
		super.onResume();
		//스레드 멈추는거 추가
		check = false;
		threadcheck = false;	
		 selectData();
		 parser();
		//select 해서
		//timer.schedule 재 설정
		//날씨 지역 재설정
		
	}

	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {
	}

	public void surfaceCreated(SurfaceHolder holder) {
		gameLoop = new GameLoop();
		gameLoop.start();
	}

	public void surfaceDestroyed(SurfaceHolder holder) {
		try {
			threadcheck = true;
			gameLoop.safeStop();
			gameLoop.join();
			/*
			  videothread.cancel();
			  videotimer.cancel();
			  */
			  weatherthread.cancel();
			  weathertimer.cancel();

		} catch (InterruptedException e) {

			e.printStackTrace();
		} finally {
			gameLoop = null;
		}
	}

	private void draw() {
		Canvas c = null;
		try {
			c = holder.lockCanvas();

			if (c != null) {
				doDraw(c);
			}
		} finally {
			if (c != null) {
				holder.unlockCanvasAndPost(c);
			}
		}
	}

	private void doDraw(Canvas c) {
		int width = c.getWidth();
		int height = c.getHeight();

		String strtime = new Date().toString();
		strtime = strtime.substring(0, 20);
		Bitmap resize = Bitmap.createScaledBitmap(backgroundBitmap, width, height, true);
		c.drawBitmap(resize, 0, 0, null);		
		c.drawRect(45, 80, 430, 180, backgroundPaint);
		c.drawText(strtime, 55, 120, mPaint);
		c.drawBitmap(mImage, 100, 140, null);
		c.drawText(weather, 150, 160, mPaintweather);		
	}

	@Override
	public boolean onTouchEvent(MotionEvent me) {
		if (check == false) {
			check = true;
			Intent intent = new Intent();
			intent.setClass(Stretching.this, setting.class);
			startActivity(intent);

		}
		return false;
	}

	
	private class GameLoop extends Thread {
		private volatile boolean running = true;


		public void run() {
			while (running) {
				try {
					TimeUnit.MILLISECONDS.sleep(50);
					draw();					
				} catch (InterruptedException ie) {
					running = false;
				}
			}
		}

		public void safeStop() {
			running = false;
			interrupt();
		}
	}
	
	public void selectData() {
		// TODO Auto-generated method stub
		String sql = "SELECT hour,min,region FROM ";
		sql += T_NAME;
		try {

			Cursor all = db.query("stretching", null, null, null, null, null,
					null, null);

			if (all.moveToFirst()) {

				do {
					String str =  all.getString(0);
					threadtimehour =  (Integer.parseInt(str))*3600000;
					str =  all.getString(1);
					threadtimemin = (Integer.parseInt(str))*60000;					
					
					selectregion = all.getString(2);
					showToast("(" + selectregion + ")");
				} while (all.moveToNext());
			}
		} catch (SQLException se) {
		}
	}

	public void openDB() {
		db = openOrCreateDatabase(DB_NAME, DB_MODE, null);
		showToast("DB(" + DB_NAME + ")  열림");
	}

	public void createTable() {
		
		String sql = "create table ";
		sql += T_NAME;
		sql += "(hour int, min int,location text)";

		try {
			db.execSQL(sql);
		showToast("Table(" + T_NAME + ") 테이블 생성");
		} catch (SQLException se) {

		}
	}


	private boolean execSQL(String sql) {
		try {
			db.execSQL(sql);
			return true;
		} catch (SQLException se) {
		
			return false;
		}
	}

	private void showToast(String msg) {
		//Toast.makeText(this, msg, Toast.LENGTH_SHORT).show();
	}
	
	public void parser() {

		try {
			URL url = new URL(
					"http://www.kma.go.kr/XML/weather/sfc_web_map.xml");
			XmlPullParserFactory parserFactory = XmlPullParserFactory
					.newInstance();
			XmlPullParser parser = parserFactory.newPullParser();
			parser.setInput(url.openStream(), "utf-8");

			int parserEvent = parser.getEventType();
			String tag = "ready..!";

			String stnid = "";
			String desc = "";
			String ta = "";
			String region = "";

			while (parserEvent != XmlPullParser.END_DOCUMENT) {

				switch (parserEvent) {
				case XmlPullParser.START_DOCUMENT:
					Log.d("parserTest", "Parser Start..!");
					break;
				case XmlPullParser.START_TAG:
					tag = parser.getName();
					if (tag.equals("local")) {
						stnid = parser.getAttributeValue(null, "stn_id");
						desc = parser.getAttributeValue(null, "desc");
						ta = parser.getAttributeValue(null, "ta");
					}
					break;
				case XmlPullParser.TEXT:
					if (tag.equals("local")) {
						region = parser.getText();
					}
					break;

				case XmlPullParser.END_TAG:
					if (tag.equals("local")) {
						if (region.equals(selectregion))
							CustomRow(region, desc, ta, stnid);
					}
					tag = "nothing";
					break;
				}
				parserEvent = parser.next();
			}

		} catch (Exception e) {
			e.printStackTrace();
			Log.d("parserTest", "error");
		}
	}
	
	public void CustomRow(String region, String desc, String ta, String stnid) {
		weather = " ";
		weather += desc  + "  " +ta   + "  " + region ;

		if (desc.equals("맑음") | desc.equals("-")) {
			mImage = mManImage[0];
		} else if (desc.equals("비")) {
			mImage = mManImage[1];
		}
		else if (desc.equals("구름조금") | desc.equals("구름많음")) {
			mImage = mManImage[2];
		}else if (desc.equals("박무") | desc.equals("안개")) {
			mImage = mManImage[3];
		}
	}
}