package com.tistory.uiandwe;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class setting extends Activity {

	int hour = 0;
	int min = 0;
	TextView hourtext;
	TextView mintext;
	int threadtimehour = 30000;
	int threadtimemin = 30000;
	TextView timevaluetext;
	String selectregion = "";
	private final static String T_NAME = "stretching";
	private SQLiteDatabase db;
	private final static String DB_NAME = "uiandwe.db"; // DB name setting
	private final static int DB_MODE = Context.MODE_PRIVATE;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.setting);

		timevaluetext = (TextView) findViewById(R.id.timevaluetext);

		Button videobutton = (Button) findViewById(R.id.videobtn);
		videobutton.setOnClickListener(videobuttonListener);

		Button regionbutton = (Button) findViewById(R.id.regionbtn);
		regionbutton.setOnClickListener(regionbuttonListener);

		View v;
		LayoutInflater vi = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		v = vi.inflate(R.layout.dialog, null);
		hourtext = (TextView) v.findViewById(R.id.hourtext);
		mintext = (TextView) v.findViewById(R.id.mintext);

		Button hourplus = (Button) v.findViewById(R.id.hourplus);
		Button minplus = (Button) v.findViewById(R.id.minplus);

		hourplus.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				hour++;
				if (hour > 23)
					hour = 0;
				settimetext();
			}
		});

		minplus.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				min++;
				if (min > 59)
					min = 0;
				settimetext();
			}
		});

		Button hourminus = (Button) v.findViewById(R.id.hourminus);
		Button minminus = (Button) v.findViewById(R.id.minminus);

		hourminus.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				hour--;
				if (hour < 0)
					hour = 23;
				settimetext();
			}
		});

		minminus.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				min--;
				if (min < 0)
					min = 59;
				settimetext();
			}
		});

		Button button1 = (Button) v.findViewById(R.id.button1);
		Button button2 = (Button) v.findViewById(R.id.button2);

		final Dialog mDialog = new AlertDialog.Builder(this).setView(v)
				.create();

		button1.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				threadtimehour = hour;
				threadtimemin = min;
				mDialog.cancel();
			}
		});

		button2.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				mDialog.cancel();
			}
		});

		Button settingbutton = (Button) findViewById(R.id.timebtn);
		settingbutton.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				mDialog.show();
			}
		});

	}

	public void settimetext() {
		hourtext.setText("" + hour);
		mintext.setText("" + min);
	}

	protected void onResume() {
		super.onResume();
		openDB();
		selectData();
	}

	protected void onPause() {
		super.onPause();
		openDB();
		deleteData();
		 insertData(threadtimehour,threadtimemin, selectregion);
		 
	}

	private OnClickListener videobuttonListener = new OnClickListener() {
		public void onClick(View v) {

			Intent intent = new Intent();
			intent.setClass(setting.this, VideoActivity.class);
			startActivity(intent);
		}
	};

	private OnClickListener regionbuttonListener = new OnClickListener() {
		public void onClick(View v) {
			onCreateDialog().show();
		}
	};

	protected Dialog onCreateDialog() {
		return new AlertDialog.Builder(setting.this).setTitle("지역 선택")
				.setItems(R.array.listarray,
						new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog,
									int which) {
								/* User clicked so do some stuff */
								String[] items = getResources().getStringArray(
										R.array.listarray);
								selectregion = items[which];

							}
						}).create();
	}

	public void openDB() {
		db = openOrCreateDatabase(DB_NAME, DB_MODE, null);
		showToast("DB(" + DB_NAME + ")  열림");
	}
	
	public void selectData() {
		// TODO Auto-generated method stub
		String sql = "SELECT hour,min,region FROM ";
		sql += T_NAME;

		try {

			Cursor all = db.query("stretching", null, null, null, null, null,
					null, null);

			if (all.moveToFirst()) {

				do {
					String str = all.getString(0);
					threadtimehour = (Integer.parseInt(str)) * 3600000;
					str = all.getString(1);
					threadtimemin = (Integer.parseInt(str)) * 60000;
					selectregion = all.getString(2);
					showToast("(" + selectregion + ")");
				} while (all.moveToNext());
			}
		} catch (SQLException se) {
		}
	}

	public void insertData(int hour, int min, String region) {
		// TODO Auto-generated method stub
		String sql = "INSERT INTO ";
		sql += T_NAME;
		sql += " VALUES ( ";

		sql += hour;
		sql += ",";
		sql += min ;
		sql += ",";
		sql += "'" + region + "'" + ")";

		if (!this.execSQL(sql)) {
			showToast("Data(" + T_NAME + ")insert Error!");
		} else {
			showToast("Data(" + T_NAME + ")insert OK!");
		}
		showToast(selectregion);
	}

	private void deleteData() {
		// TODO Auto-generated method stub
		String sql = "delete from ";
		sql += T_NAME;

		if (!this.execSQL(sql)) {
			// showToast("Data(" + T_NAME + ")delete Error!");
		} else {
			showToast("Data(" + T_NAME + ") delete  OK!");
		}
	}

	private boolean execSQL(String sql) {
		try {
			db.execSQL(sql);
			return true;
		} catch (SQLException se) {
			// TODO: handle exception
			return false;
		}
	}

	private void showToast(String msg) {
		// TODO Auto-generated method stub
		//Toast.makeText(this, msg, Toast.LENGTH_SHORT).show();
	}
}
